//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : 7SEGMENT
// BOARD    : ZL16AVR (with ATmega88 in socket U1)
// COMPILER : WinAVR 20080610
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple 7-segment LED display demonstration.
//
//    Settings and connections on ZL16AVR:
//        A (7SEG/con14) - PD0 (con18)
//        B (7SEG/con14) - PD1 (con18)
//        C (7SEG/con14) - PD2 (con18)
//        D (7SEG/con14) - PD3 (con18)
//        E (7SEG/con14) - PD4 (con18)
//        F (7SEG/con14) - PD5 (con18)
//        G (7SEG/con14) - PD6 (con18)
//        . (7SEG/con14) - PD7 (con18)
//
//        0 (7SEG/con14) - PB0 (con16)
//        1 (7SEG/con14) - PB1 (con16)
//        2 (7SEG/con14) - PB2 (con16)
//        3 (7SEG/con14) - PB3 (con16)
//
//******************************************************************************
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

volatile unsigned char DisplayCounter;
volatile unsigned char Digit0, Digit1, Digit2, Digit3;

// Digits patterns
unsigned char Digits[]= {192, 249, 164, 176, 153, 146, 130, 248, 128, 144, 136, 131, 198, 161, 134, 142};

//-------------------------------------
// main program
//-------------------------------------
int main(void)
{
PORTD = 0xFF;			// Ports initialization
PORTB = 0xFF;			//
DDRD = 0xFF;			//
DDRB = 0xFF;			//

TCCR0B = (1 << CS02);   // Prescale by 256
TIMSK0 = (1 << TOIE0);  // Timer0 overflow interrupt enable

sei();					// Enable interupts

Digit0=Digits[0];		// write digit '0' pattern to Ditig0
Digit1=Digits[1];		// write digit '1' pattern to Ditig1
Digit2=Digits[2];		// write digit '2' pattern to Ditig2
Digit3=Digits[3];		// write digit '3' pattern to Ditig3

while(1)
  {};
return 0;
}
//-------------------------------------
// Timer0 overflow handler
//-------------------------------------
ISR(TIMER0_OVF_vect)
{
DisplayCounter++;
switch(DisplayCounter){
case 1: 
PORTB |= (1<<PB3);		// DS3 off
PORTD = Digit0;			// write digit to port
PORTB &= ~(1 << PB0);	// DS0 on
break;
case 2: 
PORTB |= (1<<PB0);		// DS0 off
PORTD = Digit1;			// write digit to port
PORTB &= ~(1 << PB1);	// DS1 on
break;
case 3:
PORTB |= (1<<PB1);		// DS1 off
PORTD = Digit2;			// write digit to port
PORTB &= ~(1 << PB2);	// DS2 on
break;
case 4: 
PORTB |= (1<<PB2);		// DS2 off
PORTD = Digit3;			// write digit to port
PORTB &= ~(1 << PB3);	// DS3 on
DisplayCounter=0;
break;
}
}
//-------------------------------------
// End of file
//-------------------------------------
