//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : ADC_POT
// BOARD    : ZL16AVR (with ATmega88 in socket U1)
// COMPILER : WinAVR 20080610
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple AD conversion. Input voltage is selected by potentiometer P2.
//    Result of conversion is transmitted to PC.
//
//    Settings and connections on ZL16AVR:
//        P2 (con7) - PA0 (con15)
//
//      if RS232 cable connected:
//        RxD (con7) - PD0 (con18)
//        TxD (con7) - PD1 (con18)
//
//      if UART2USB converter (ZL1USB_A or ZL4USB) connected:
//        RxU (con7) - PD0 (con18)
//        TxU (con7) - PD1 (con18)
//
//******************************************************************************
#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>
#include "USART.h"
#include "ADC.h"

//-------------------------------------
// main program
//-------------------------------------
int main(void)
{

char str[8];
DDRD = 0xFF;

USART_Init(BAUD(1200));

USART_PutChar('\r');
USART_PutString("*************************\r");
USART_PutString("**   ZL16AVR ADC_POT   **\r");
USART_PutString("**    www.kamami.com   **\r");
USART_PutString("*************************\r");

ADC_Init();

do{
USART_PutString("Channel 0 Value:");
USART_PutString(itoa(getADC(0),str,10));
USART_PutString("\r");
}while(1);

return 0;
}
//-------------------------------------
// End of file
//-------------------------------------
