//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : CHAR LCD
// BOARD    : ZL16AVR (with ATmega88 in socket U1)
// COMPILER : WinAVR 20080610
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Using LCD graphic display (KS0108 compatible)
//
//    Settings and connections on ZL16AVR:
//        JP4 (DISPLAY) - 1-2 (=GRAPH)
//
//        D0 (LCD_GRAPH/con12) - PD0 (con18)
//        D1 (LCD_GRAPH/con12) - PD1 (con18)
//        D2 (LCD_GRAPH/con12) - PD2 (con18)
//        D3 (LCD_GRAPH/con12) - PD3 (con18)
//        D4 (LCD_GRAPH/con12) - PD4 (con18)
//        D5 (LCD_GRAPH/con12) - PD5 (con18)
//        D6 (LCD_GRAPH/con12) - PD6 (con18)
//        D7 (LCD_GRAPH/con12) - PD7 (con18)
//
//        RS (LCD_GRAPH/con12) - PB0 (con16)
//        RW (LCD_GRAPH/con12) - PB1 (con16)
//        E  (LCD_GRAPH/con12) - PB2 (con16)
//        CS1(LCD_GRAPH/con12) - PB3 (con16)
//        CS2(LCD_GRAPH/con12) - PB4 (con16)
//
//******************************************************************************
#ifndef F_CPU  
  #define F_CPU   16000000    // 16 MHz - turn on external resonator (fuse bits)
#endif

#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>
#include "KS0108.h"
#include "kamami.h"

//-------------------------------------
// main program
//-------------------------------------
int main(void)
{
unsigned char i;

GLCD_Initialize();								// LCD initialization

do{
GLCD_ClearScreen();								// clear screen

GLCD_WriteStringXY("   K A M A M I",12,0);		//
GLCD_WriteStringXY("development board",12,1);	// display text
GLCD_WriteStringXY(" -- ZL16AVR --  ",12,3);	//
GLCD_WriteStringXY(" www.kamami.com ",12,4);	//

for(i = 0; i < 200; i++)						// wait2 seconds
  _delay_ms(10);								//

GLCD_Bitmap(kamami,0,0,128,64);					// display picture

for(i = 0; i < 200; i++)						// wait 2 seconds
  _delay_ms(10);								//

}while(1);
return 0;
}
//-------------------------------------
// End of file
//-------------------------------------
