//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : RTC
// BOARD    : ZL16AVR (with ATmega88 in socket U1)
// COMPILER : WinAVR 20080610
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple I2C communication demo.
//    Read all registers from RTC (U6 - M41T00)
//    and transmit it to PC via UART.
//
//    Settings and connections on ZL16AVR:
//        SCL (U6 RTC/con7) - PC5 (con17)
//        SDA (U6 RTC/con7) - PC4 (con17)
//
//      if RS232 cable connected:
//        RxD (con7) - PD0 (con18)
//        TxD (con7) - PD1 (con18)
//
//      if UART2USB converter (ZL1USB_A or ZL4USB) connected:
//        RxU (con7) - PD0 (con18)
//        TxU (con7) - PD1 (con18)
//
//******************************************************************************
#ifndef F_CPU
  #define F_CPU 16000000 // 16 MHz - turn on external resonator (fuse bits)
#endif

#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>
#include "USART.h"
#include "TWI.h"
//-------------------------------------
// main program
//-------------------------------------
int main(void)
{
char i,j, B1;
char str[5];
DDRD = 0xFF;

USART_Init(BAUD(1200));

TWI_Init();

USART_PutString("\r");
USART_PutString("*************************\r");
USART_PutString("**     ZL16AVR  RTC    **\r");
USART_PutString("**    www.kamami.com   **\r");
USART_PutString("*************************\r");

do{
TWI_Start();                                    // start transmission
TWI_Write(0xD0);                                // write addres of M41T00
TWI_Write(0x00);                                // select first register
TWI_Start();                                    // repeated start
TWI_Write(0xD1);                                // write address for reading data

for(i = 0; i < 8; i++)
  {
  B1 = TWI_Read((i==7)?NACK:ACK);               // read data
  USART_PutString("M41T00 byte ");              
  USART_PutChar(i+'0');                         // convert to ASCII char
  USART_PutString(" value ");
  USART_PutString(Hex(B1,str));                 // convert to HEX value
  USART_PutChar('\r');
  }
TWI_Stop();                                     // stop transmission
USART_PutString("------------------------------------------\r");

for(j = 0; j < 20; j++)                         //
  _delay_ms(10);                                // wait 200 miliseconds
}while(1);
return 0;
}
//-------------------------------------
// End of file
//-------------------------------------
