//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
//PROJECT  : UART
//BOARD    : ZL16AVR (with ATmega88 in socket U1)
//COMPILER : WinAVR 20080610
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple UART communication demo.
//
//    Settings and connections on ZL16AVR:
//        JP4 (DISPLAY) - 2-3 (=CHAR)
//
//        D4 (LCD_CHAR/con13) - PD4 (con18)
//        D5 (LCD_CHAR/con13) - PD5 (con18)
//        D6 (LCD_CHAR/con13) - PD6 (con18)
//        D7 (LCD_CHAR/con13) - PD7 (con18)
//        E  (LCD_CHAR/con13) - PB2 (con16)
//        RS (LCD_CHAR/con13) - PB0 (con16)
//        RW (LCD_CHAR/con13) - GND (con15)
//
//      if RS232 cable connected:
//        RxD (con7) - PD0 (con18)
//        TxD (con7) - PD1 (con18)
//
//      if UART2USB converter (ZL1USB_A or ZL4USB) connected:
//        RxU (con7) - PD0 (con18)
//        TxU (con7) - PD1 (con18)
//
//******************************************************************************
#include <avr/io.h>
#include <util/delay.h>
#include "HD44780.h"
#include "USART.h"
//-------------------------------------
// main program
//-------------------------------------
int main(void)
{
char str[17];
DDRD = 0xFF;

USART_Init(BAUD(1200));

LCD_Initialize();
LCD_GoTo(0,0);
LCD_WriteText(" ZL16AVR - UART");
LCD_GoTo(0,1);
LCD_WriteText(" www.kamami.com");

USART_PutChar('\r');
USART_PutString("*************************\r");
USART_PutString("**     ZL16AVR  UART   **\r");
USART_PutString("**    www.kamami.com   **\r");
USART_PutString("*************************\r");

do{
  USART_PutString("->");USART_GetString(str);
  USART_PutString("<-");USART_PutString(str);
  LCD_Clear();
  LCD_GoTo(0,0);
  LCD_WriteText("Rx:");
  LCD_GoTo(0,1);
  LCD_WriteText(str);
}while(1);
return 0;
}
//-------------------------------------
// End of file
//-------------------------------------
